<!DOCTYPE html>
<html>
<head>
<link href="/webjars/bootstrap/css/bootstrap.min.css" rel="stylesheet">
<link href="/leaflet/leaflet.css" rel="stylesheet" />
<script src="/webjars/jquery/jquery.min.js"></script>
<script src="/webjars/sockjs-client/sockjs.min.js"></script>
<script src="/webjars/stomp-websocket/stomp.min.js"></script>
<script src="/leaflet/leaflet.js"></script>
</head>
<body>
	<br>
<!-- 	<div class="row"> -->
		<div class="col-xs-6">
			<div class="panel panel-default">
				<div class="panel-heading">客戶貢獻度</div>
				<div id="customer_bill" class="panel-body" style="height: 500px;"></div>
			</div>		
		</div>
		<div class="col-xs-6">
			<div class="panel panel-default">
				<div class="panel-heading">產品貢獻度</div>
				<div id="product_bill" class="panel-body" style="height: 500px;"></div>
			</div>		
		</div>
<!-- 	</div> -->
		<div class="col-xs-12">
			<div class="panel panel-default">
				<div class="panel-heading">時間序列</div>
				<div id="timeseries" class="panel-body" style="width: 100%; height: 400px;"></div>
			</div>	
		</div>
		<div class="col-xs-6">
			<div class="panel panel-default">
				<div class="panel-heading">銷售地圖</div>
				<div id="mapid" class="panel-body" style="height: 400px;"></div>
			</div>		
		</div>
		<div class="col-xs-6">
			<div class="panel panel-default">
				<div class="panel-heading">銷售警示</div>
				<div class="panel-body" style="height: 400px;">
					<table class="table table-striped">
						<thead>
							<tr>
								<th>時間</th>
								<th>地點</th>
								<th>商品</th>
								<th>金額</th>		
							</tr>
						</thead>
						<tbody id="targetTBody">
						</tbody>
					</table>
				</div>
			</div>		
		</div>
	<script
		src="/echarts-2.2.4/echarts.js"></script>
	<script type="text/javascript">
		require
				.config({
					paths : {
						echarts : '/echarts-2.2.4'
					}
				});
// 		customer bill
		customer_option = {
			title : {
				text : ''
			},
			tooltip : {
				trigger : 'item',
				formatter: "{a} <br/>{b} : {c} ({d}%)"
			},
			toolbox: {
				show : true,
				feature : {
					mark : {show: true},
					dataView : {show: true, readOnly: false},
					magicType : {
						show: true, 
						type: ['pie', 'funnel'],
						option: {
							funnel: {
								x: '25%',
								width: '50%',
								funnelAlign: 'left',
								max: 1548
							}
						}
					},
					restore : {show: true},
					saveAsImage : {show: true}
				}
			},
			calculable : true,
			series : [
				{
					name : 'data',
					type : 'pie',
					radius : '55%',
					center: ['50%', '60%'],
					data:[
						{"value":0,"name":"cust_0"}
					]
				}
			]
		};
		require([ 'echarts', 'echarts/chart/pie' ], function(ec) {
			var customerChart = ec.init(document.getElementById('customer_bill'));
			customerChart.setOption(customer_option);
		    var socket = new SockJS('/endpoint');
		    stompClient = Stomp.over(socket);
		    stompClient.connect({}, function (frame) {
		        stompClient.subscribe('/customer_bill_topic/response', function (response) {
		        	var json = JSON.parse(response.body);
		        	customer_option.series[0].data = json;
		        	customerChart.setOption(customer_option);
		        });
		    });
		});
// 		product bill
		product_option = {
			title : {
				text : ''
			},
			tooltip : {
				trigger : 'item',
				formatter: "{a} <br/>{b} : {c} ({d}%)"
			},
			toolbox: {
				show : true,
				feature : {
					mark : {show: true},
					dataView : {show: true, readOnly: false},
					magicType : {
						show: true, 
						type: ['pie', 'funnel'],
						option: {
							funnel: {
								x: '25%',
								width: '50%',
								funnelAlign: 'left',
								max: 1548
							}
						}
					},
					restore : {show: true},
					saveAsImage : {show: true}
				}
			},
			calculable : true,
			series : [
				{
					name : 'data',
					type : 'pie',
					radius : '55%',
					center: ['50%', '60%'],
					data:[
						{"value":0,"name":"cust_0"}
					]
				}
			]
		};
		require([ 'echarts', 'echarts/chart/pie' ], function(ec) {
			var productChart = ec.init(document.getElementById('product_bill'));
			productChart.setOption(product_option);
		    var socket = new SockJS('/endpoint');
		    stompClient = Stomp.over(socket);
		    stompClient.connect({}, function (frame) {
		        stompClient.subscribe('/product_bill_topic/response', function (response) {
		        	var json = JSON.parse(response.body);
		        	product_option.series[0].data = json;
		        	productChart.setOption(product_option);
		        });
		    });
		});
// 		timeseries
		timeseries_option = {
		    title : {
		        text: ''
		    },
		    tooltip : {
		        trigger: 'axis'
		    },
		    legend: {
		        data:['成交數量', '成交金額']
		    },
		    toolbox: {
		        show : true,
		        feature : {
		            mark : {show: true},
		            dataView : {show: true, readOnly: false},
		            magicType : {show: true, type: ['line', 'bar']},
		            restore : {show: true},
		            saveAsImage : {show: true}
		        }
		    },
		    dataZoom : {
		        show : false,
		        start : 0,
		        end : 100
		    },
		    xAxis : [
		        {
		            type : 'category',
		            boundaryGap : true,
		            data : (function (){
		                var res = [];
		                var len = 20;
		                while (len--) {
// 		                    res.push(len + 1);
		                	res.push("");
		                }
		                return res;
		            })()
		        },
		        {
		            type : 'category',
		            boundaryGap : true,
		            data : (function (){
		                var res = [];
		                var len = 20;
		                while (len--) {
// 		                    res.push(len + 1);
		                	res.push("");
		                }
		                return res;
		            })()
		        }
		    ],
		    yAxis : [
		        {
		            type : 'value',
		            scale: true,
		            name : '數量',
		            boundaryGap: [0.2, 0.2]
		        },
		        {
		            type : 'value',
		            scale: true,
		            name : '金額',
		            boundaryGap: [0.2, 0.2]
		        }
		    ],
		    series : [
		        {
		            name:'成交數量',
		            type:'bar',
		            xAxisIndex: 1,
		            yAxisIndex: 1,
		            data:(function (){
		                var res = [];
		                var len = 20;
		                while (len--) {
		                    res.push(0);
		                }
		                return res;
		            })()
		        },
		        {
		            name:'成交金額',
		            type:'line',
		            data:(function (){
		                var res = [];
		                var len = 20;
		                while (len--) {
		                    res.push(0);
		                }
		                return res;
		            })()
		        }
		    ]
		};
		require([ 'echarts', 'echarts/chart/line', 'echarts/chart/bar' ], function(ec) {
			var timeseriesChart = ec.init(document.getElementById('timeseries'));
			timeseriesChart.setOption(timeseries_option);
		    var socket = new SockJS('/endpoint');
		    stompClient = Stomp.over(socket);
		    stompClient.connect({}, function (frame) {
		        stompClient.subscribe('/timeseries_topic/response', function (response) {
		        	var json = JSON.parse(response.body);
		        	timeseriesChart.addData(json);
		        });
		    });
		});

		require([ 'echarts', 'echarts/chart/line', 'echarts/chart/bar' ], function(ec) {
			var latitude = 25.0616509;
			var longitude = 121.6039325;
			var zoom = 11;
			var mymap = L.map('mapid').setView([latitude, longitude], zoom);
			L.tileLayer('https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=pk.eyJ1IjoiaHNpZWhwaW5naGFuIiwiYSI6ImNqanRxaWE2YTAzeWYzdnF1ejVtZXRxa2EifQ.uU23cf-VDsp2GefncgMGug', {
				maxZoom: 18,
				id: 'mapbox.streets'
			}).addTo(mymap);
		    var socket = new SockJS('/endpoint');
		    stompClient = Stomp.over(socket);
		    stompClient.connect({}, function (frame) {
		        stompClient.subscribe('/map_topic/response', function (response) {
		        	var json = JSON.parse(response.body);
		        	for(i in json) {
		        		loc = json[i];
		        		L.marker([loc.latitude, loc.longitude]).addTo(mymap);
		        	}
		        });
		    });	  
		});

		require([ 'echarts', 'echarts/chart/line', 'echarts/chart/bar' ], function(ec) {
	 	    var socket = new SockJS('/endpoint');
	 	    stompClient = Stomp.over(socket);
	 	    stompClient.connect({}, function (frame) {
	 	        stompClient.subscribe('/warning_topic/response', function (response) {
 	        	    var tBody = document.getElementById("targetTBody");
	 	        	var json = JSON.parse(response.body);
		        	for(i in json) {
	 	        		warning = json[i];
	 	        	    var tr = document.createElement("tr");
	 	        	    tBody.appendChild(tr);
	 	        	    var td_time = document.createElement("td");
	 	        	    tr.appendChild(td_time);
	 	        	    td_time.appendChild(document.createTextNode(warning.time));
	 	        	    
	 	        	    var td_latitude = document.createElement("td");
	 	        	    tr.appendChild(td_latitude);
	 	        	    td_latitude.appendChild(document.createTextNode(warning.latitude + " , " + warning.longitude));

	 	        	    var td_product = document.createElement("td");
	 	        	    tr.appendChild(td_product);
	 	        	    td_product.appendChild(document.createTextNode(warning.product));

	 	        	    var td_bill = document.createElement("td");
	 	        	    tr.appendChild(td_bill);
	 	        	    td_bill.appendChild(document.createTextNode(warning.bill));
	 	        	    
	 	        	}
		        });
	 	    });  
		});
	</script>

</body>
</html>
